<?php

/**
 * E-goi.com
 *
 * @title      E-Goi Multi-channel Marketing
 * @package    E-Goi
 * @copyright  Copyright (c) 2012-2023 E-Goi - https://e-goi.com
 */

namespace Egoi\Marketing\Controller\Adminhtml\Lists;

/**
 * Class Index
 *
 * @package Egoi\Marketing\Controller\Adminhtml\Lists
 */
class Index extends \Egoi\Marketing\Controller\Adminhtml\Lists
{

    /**
     * @return \Magento\Backend\Model\View\Result\Page|\Magento\Backend\Model\View\Result\Redirect
     */
    public function execute()
    {

        $auth = $this->_egoi->validateEgoiEnvironment();
        if (!$auth) {
            return $this->resultRedirectFactory->create()->setPath('*/account/new');
        }

        $exists = $this->_listsFactory->create()->listExists();
        if (!$exists) {
            $this->messageManager->addErrorMessage(
                __('Remote List does not Exist Locally. Please Clear your Data and Sync with E-Goi again.')
            );

            return $this->resultRedirectFactory->create()->setPath('*/account/');
        }

        parent::execute();
        $list = $this->_coreRegistry->registry('egoi_list');

        $this->_redirect('*/*/edit', ['id' => $list->getId()]);

        $resultPage = $this->_initAction();

        $resultPage->addContent($resultPage->getLayout()->createBlock('Egoi\Marketing\Block\Adminhtml\Lists\Grid'));

        return $resultPage;
    }
}
