<?php

namespace Egoi\Marketing\Controller\Products;

/**
 * Class Index
 *
 * @package Egoi\Marketing\Controller\Products
 */
class Get extends \Magento\Framework\App\Action\Action
{

    /**
     * @var \Magento\Newsletter\Model\SubscriberFactory
     */
    protected $subscriberFactory;

    /**
     * @var \Magento\Framework\Registry
     */
    protected $registry;

    /**
     * @var \Magento\Framework\Controller\Result\RawFactory
     */
    protected $resultRawFactory;

    /**
     * @param \Magento\Framework\Controller\Result\RawFactory $resultRawFactory
     * @param \Magento\Framework\Registry                     $registry
     * @param \Magento\Newsletter\Model\SubscriberFactory     $subscriberFactory
     * @param \Magento\Framework\App\Action\Context           $context
     */
    public function __construct(
        \Magento\Framework\Controller\Result\RawFactory $resultRawFactory,
        \Magento\Framework\Registry                     $registry,
        \Magento\Newsletter\Model\SubscriberFactory     $subscriberFactory,
        \Magento\Framework\App\Action\Context           $context
    )
    {

        $this->resultRawFactory = $resultRawFactory;
        $this->subscriberFactory = $subscriberFactory;
        $this->registry = $registry;

        parent::__construct($context);
    }

    /**
     *
     */
    public function execute()
    {

        $subscriber = new \Magento\Framework\DataObject();

        $email = $this->getRequest()->getParam('email');
        $uid = $this->getRequest()->getParam('uid');

        $params = $this->getRequest()->getParams();

        $paramsDefault = [];
        $paramsDefault['number_products'] = 10;
        $paramsDefault['title'] = '';
        $paramsDefault['sort_results'] = 'price';
        $paramsDefault['segments'] = 'new';
        $paramsDefault['template'] = 'products';
        $paramsDefault['category'] = \Magento\Catalog\Model\Category::TREE_ROOT_ID;

        $params = array_merge($paramsDefault, $params);

        if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
            $subscriber = $this->subscriberFactory->create()->load($email, 'email');
        }

        if (!$subscriber->getId()) {
            $subscriber = $this->subscriberFactory->create()->load($uid, 'uid');
        }

        $this->registry->register('egoi_subscriber', $subscriber);

        $block = $this->_view->getLayout()->createBlock('Egoi\Marketing\Block\Products', 'egoi_products');
        $block->setData('params', $params);

        $resultRaw = $this->resultRawFactory->create();
        return $resultRaw->setContents($block->toHtml());

    }

}
