<?php

namespace Egoi\Marketing\Controller\R;

use Magento\Framework\Controller\ResultFactory;

/**
 * Class I
 *
 * @package Egoi\Marketing\Controller\Products
 */
class I extends \Magento\Framework\App\Action\Action
{

    /**
     * @var \Egoi\Marketing\Model\AutorespondersFactory
     */
    protected $_autoresponders;

    /**
     * I constructor.
     *
     * @param \Egoi\Marketing\Model\AutorespondersFactory $autorespondersFactory
     * @param \Magento\Framework\App\Action\Context       $context
     */
    public function __construct(
        \Egoi\Marketing\Model\AutorespondersFactory $autorespondersFactory,
        \Magento\Framework\App\Action\Context       $context
    )
    {

        $this->_autoresponders = $autorespondersFactory;
        parent::__construct($context);
    }

    /**
     *
     */
    public function execute()
    {

        $url = $this->_autoresponders->create()
                                     ->getRedirect($this->getRequest()->getParam('c'));

        if ($url) {
            $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
            $resultRedirect->setUrl($url);

            return $resultRedirect;
        }

        $this->messageManager->addErrorMessage(__('Ligação inválida'));
        $this->_redirect('/');
    }

}
