<?php

namespace Egoi\Marketing\Cron;

/**
 * Class SyncCatalog
 *
 * @package Egoi\Marketing\Cron
 */
class SyncCatalog
{

    /**
     * @var \Magento\Store\Model\System\Store
     */
    private $systemStore;

    /**
     * @var \Egoi\Marketing\Model\Egoi
     */
    protected $egoi;

    /**
     * SyncCatalog constructor.
     *
     * @param \Magento\Store\Model\System\Store $systemStore
     * @param \Egoi\Marketing\Model\Egoi        $egoi
     */
    public function __construct(
        \Magento\Store\Model\System\Store $systemStore,
        \Egoi\Marketing\Model\Egoi        $egoi
    )
    {

        $this->systemStore = $systemStore;
        $this->egoi = $egoi;
    }

    /**
     */
    public function execute()
    {

        foreach ($this->systemStore->getStoreOptionHash() as $storeId => $storeName) {

            $this->egoi->buildProductsFeed($storeId);

        }

    }

}

