<?php

/**
 * E-goi.com
 *
 * @title      E-Goi Multi-channel Marketing
 * @package    E-Goi
 * @copyright  Copyright (c) 2012-2023 E-Goi - https://e-goi.com
 */

namespace Egoi\Marketing\Model\Source;

/**
 *
 */
class ConnectedSite
{

    /**
     * @var \Egoi\marketing\Model\Egoi
     */
    protected $egoi;

    /**
     * @param \Egoi\Marketing\Model\Egoi $egoi
     */
    public function __construct(\Egoi\Marketing\Model\Egoi $egoi
    )
    {

        $this->egoi = $egoi;
    }

    /**
     * @return array
     */
    public function toOptionArray()
    {

        $return = [];

        $sites = $this->egoi->getConnectedSiteList();
        $return[] = [
            'value' => 0,
            'label' => __('No'),
        ];
        $return[] = [
            'value' => 1,
            'label' => __('Yes - Create New Connected Website Automatically'),
        ];
        foreach ($sites as $site) {

            $return[] = [
                'value' => $site['domain'],
                'label' => $site['domain'],
            ];
        }

        return $return;
    }

}
