<?php

/**
 * E-goi.com
 *
 * @title      E-Goi Multi-channel Marketing
 * @package    E-Goi
 * @copyright  Copyright (c) 2012-2023 E-Goi - https://e-goi.com
 */

namespace Egoi\Marketing\Model\Source;

/**
 * Class Sender
 *
 * @package Egoi\Marketing\Model\Source
 */
class Sender
{

    /**
     * @var \Egoi\Marketing\Model\Egoi
     */
    protected $egoi;

    /**
     * Sender constructor.
     *
     * @param \Egoi\Marketing\Model\Egoi $egoi
     */
    public function __construct(
        \Egoi\Marketing\Model\Egoi $egoi
    )
    {

        $this->egoi = $egoi;
    }

    /**
     * @return array
     */
    public function toOptionArray()
    {

        $senders = $this->egoi->getSMSSenders();
        $return = [];
        foreach ($senders as $sender) {
            $return[] = ['value' => $sender['sender_id'], 'label' => $sender['cellphone']];
        }

        return $return;
    }

}
