<?php

namespace Egoi\Marketing\Observer;

use Magento\Framework\Event\ObserverInterface;

/**
 * Class NewLogin
 *
 * @package Egoi\Marketing\Observer
 */
class NewCustomer implements ObserverInterface
{

    /**
     * @var \Egoi\Marketing\Model\SubscriberFactory
     */
    protected $subscriber;

    /**
     * @param \Egoi\Marketing\Model\SubscriberFactory $subscriber
     */
    function __construct(
        \Egoi\Marketing\Model\SubscriberFactory $subscriber
    )
    {

        $this->subscriber = $subscriber;
    }

    /**
     * @param \Magento\Framework\Event\Observer $event
     */
    public function execute(\Magento\Framework\Event\Observer $event)
    {

        try {
            /** @var \Magento\Customer\Model\Customer $customer */
            $customer = $event->getEvent()->getCustomer();

            /** @var \Magento\Customer\Controller\Account\CreatePost $customer */
            $accountController = $event->getEvent()->getAccountController();

            $isSubscribed = $accountController->getRequest()->getParam('is_subscribed', false);
            if ($isSubscribed) {
                $this->subscriber->create()->subscribe($customer->getEmail());
            }
        } catch (\Exception $e) {

        }
    }

}
