<?php

namespace Egoi\Marketing\Observer\Qero;

use Magento\Framework\Event\ObserverInterface;

/**
 *
 */
class CreditMemoRegister implements ObserverInterface
{

    /**
     * @var \Egoi\Marketing\Helper\Qero
     */
    protected $helper;

    /**
     * @param \Egoi\Marketing\Helper\Qero $helper
     */
    function __construct(
        \Egoi\Marketing\Helper\Qero $helper
    )
    {

        $this->helper = $helper;
    }

    /**
     * @param \Magento\Framework\Event\Observer $event
     *
     * @return false|void
     */
    public function execute(\Magento\Framework\Event\Observer $event)
    {

        try {
            $order = $event->getEvent()->getData('creditmemo')->getOrder();

            if ((float) $order->getBaseGrandTotal() != (float) $order->getBaseTotalRefunded()) {
                return false;
            }
            $this->helper->queroOrderCancel($order);
        } catch (\Exception $e) {
            $this->helper->getLogger()->critical($e->getMessage());
        }
    }

}
