<?php

namespace Egoi\Marketing\Observer\Qero;

use Magento\Framework\Event\ObserverInterface;

/**
 *
 */
class NewInvoiceRegister implements ObserverInterface
{

    /**
     * @var \Egoi\Marketing\Helper\Qero
     */
    protected $helper;

    /**
     * @param \Egoi\Marketing\Helper\Qero $helper
     */
    function __construct(
        \Egoi\Marketing\Helper\Qero $helper
    )
    {

        $this->helper = $helper;
    }

    /**
     * @param \Magento\Framework\Event\Observer $event
     */
    public function execute(\Magento\Framework\Event\Observer $event)
    {

        /** @var \Magento\Sales\Model\Order\Invoice $invoice */
        $invoice = $event->getData('invoice');

        /** @var \Magento\Sales\Model\Order $order */
        $order = $event->getData('order');

        if ($order->getBaseTotalInvoiced() == $order->getBaseGrandTotal()) {
            $this->helper->queroOrderRegister($order, \Egoi\Marketing\Helper\Qero::OPERATION_BUY);
        }

    }

}
